package api.beautyC.importGDT

import android.content.Context
import android.util.Log
import api.beautyC.importGDT.bean.SDKBean_NativeData
import api.beautyC.importTX.TXstreamAPI_beauC
import api.beautyC.importTX.bean.SDKBeanAPI_NativeData
import com.qq.e.ads.nativ.NativeAD
import com.qq.e.ads.nativ.NativeADDataRef
import com.qq.e.comm.util.AdError
import common.iSDK_Constance
import java.util.*

class GDTstream_beauC : TXstreamAPI_beauC() {

    override fun getnativeADDataRefStreamList(): ArrayList<SDKBeanAPI_NativeData> {
        return if (nativeDataRefStreamList == null)
            ArrayList<SDKBeanAPI_NativeData>()
        else
            nativeDataRefStreamList as ArrayList<SDKBeanAPI_NativeData>
    }


    /***
     * 初始化并加载信息流展示广告
     */
    override fun loadStreamGDT(mContext: Context, streamAPPID: String, streamNativePosID: String, streamNativeGDTCount: Int, mCallback: TXstreamAPI_beauC.NativeGDTCallBack) {
        var streamNativeGDTCount = streamNativeGDTCount

        if (iSDK_Constance.IS_DEBUG) {
            Log.i("iSDK", "iSDK_Constance.hasSDK_GDT" + iSDK_Constance.hasSDK_GDT)
            Log.i("iSDK", "GDTstreamAPI_beauC.getInstance():" + TXstreamAPI_beauC.getInstance()!!)
        }
        val nativeAD = NativeAD(mContext, streamAPPID, streamNativePosID, object : NativeAD.NativeAdListener {

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
                if (iSDK_Constance.IS_DEBUG) {
                    Log.i("iSDK", "onGDTError")
                }
                mCallback.onGDTError()
            }

            override fun onNoAD(p0: AdError?) {
                if (iSDK_Constance.IS_DEBUG) {
                    Log.i("iSDK", "onNoGDT")
                }
                // 拉取广告失败上报统计
                //analytics.capture(BTCStatisticsUtils.STATISTICS_GDTADS_PULLFAILED_STREAM);
                mCallback.onNoGDT()
            }

            override fun onADStatusChanged(arg0: NativeADDataRef) {
                if (iSDK_Constance.IS_DEBUG) {
                    Log.i("iSDK", "onGDTStatusChanged")
                }
                mCallback.onGDTStatusChanged(arg0)
            }

            override fun onADLoaded(arg0: List<NativeADDataRef>?) {
                if (iSDK_Constance.IS_DEBUG) {
                    Log.i("iSDK", "onGDTLoaded")
                }
                if (arg0 != null && !arg0.isEmpty()) {
                    if (nativeDataRefStreamList == null) {
                        nativeDataRefStreamList = ArrayList<SDKBeanAPI_NativeData>()
                    }
                    for (bean in arg0) {
                        val ref = SDKBean_NativeData(bean)
                        nativeDataRefStreamList!!.add(ref)
                    }
                    //analytics.capture(BTCStatisticsUtils.STATISTICS_GDTADS_PULLSUCCESSED_STREAM);
                } else {
                    // 拉取广告失败
                    //analytics.capture(BTCStatisticsUtils.STATISTICS_GDTADS_PULLFAILED_STREAM);
                }
                mCallback.onGDTLoaded(arg0)
            }
        })
        if (streamNativeGDTCount <= 0) {
            streamNativeGDTCount = 3
        }
        nativeAD.loadAD(streamNativeGDTCount)
    }

    companion object {

        var nativeDataRefStreamList: ArrayList<SDKBeanAPI_NativeData>? = null
    }

}
