package api.flashlight

import android.content.Context
import api.bean.API_TX_NativeBean
import api.bean.TX_NativeBean
import com.qq.e.ads.nativ.NativeAD
import com.qq.e.ads.nativ.NativeADDataRef
import com.qq.e.comm.util.AdError
import java.util.*

/**
 * Created by cyly on 16/5/24.
 */
class Gdt_flashlight : API_TX() {
    var nativeGDTDataRefApplyList: ArrayList<API_TX_NativeBean>? = null
    var nativeGDTDataCleanApplyList: ArrayList<API_TX_NativeBean>? = null

    override fun getnativeGDTDataRefapplyList(): ArrayList<API_TX_NativeBean> {
        return if (nativeGDTDataRefApplyList == null)
            ArrayList<API_TX_NativeBean>()
        else
            nativeGDTDataRefApplyList as ArrayList<API_TX_NativeBean>
    }

    override fun getnativeCleanRefapplyList(): ArrayList<API_TX_NativeBean> {
        return if (nativeGDTDataCleanApplyList == null)
            ArrayList<API_TX_NativeBean>()
        else
            nativeGDTDataCleanApplyList as ArrayList<API_TX_NativeBean>
    }

    override fun loadCleanApply(mContext: Context, applyNativeCount: Int, mCallback: API_TX.LoadCallBack) {
        val nativeAD = NativeAD(mContext, APPID, NativePosID_CleanID, object : NativeAD.NativeAdListener {

            override fun onADLoaded(list: List<NativeADDataRef>?) {
                if (list != null && !list.isEmpty()) {
                    if (nativeGDTDataCleanApplyList == null) {
                        nativeGDTDataCleanApplyList = ArrayList<API_TX_NativeBean>()
                    } else {
                        nativeGDTDataCleanApplyList!!.clear()
                    }

                    for (bean in list) {
                        val ref = TX_NativeBean(bean)
                        nativeGDTDataCleanApplyList!!.add(ref)
                    }
                }
                mCallback.onGDTLoadSuccessed()
            }

            override fun onNoAD(p0: AdError?) {
                mCallback.onGDTLoadFailed()
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
                mCallback.onGDTLoadFailed()
            }
            override fun onADStatusChanged(nativeADDataRef: NativeADDataRef) {

            }
        })
        nativeAD.loadAD(applyNativeCount)
    }

    override fun loadGiftApply(context: Context, applyNativeCount: Int, mCallback: API_TX.LoadCallBack) {
        val nativeAD = NativeAD(context, APPID, NativePosID_GiftID, object : NativeAD.NativeAdListener {

            override fun onADLoaded(list: List<NativeADDataRef>?) {
                if (list != null && !list.isEmpty()) {
                    if (nativeGDTDataRefApplyList == null) {
                        nativeGDTDataRefApplyList = ArrayList<API_TX_NativeBean>()
                    }
                    for (bean in list) {
                        val ref = TX_NativeBean(bean)
                        nativeGDTDataRefApplyList!!.add(ref)
                    }
                }
                mCallback.onGDTLoadSuccessed()
            }


            override fun onADStatusChanged(nativeADDataRef: NativeADDataRef) {

            }

            override fun onNoAD(p0: AdError?) {
                mCallback.onGDTLoadFailed()
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
                mCallback.onGDTLoadFailed()
            }

        })
        nativeAD.loadAD(applyNativeCount)
    }

    override fun loadExitSplash(mContext: Context, applyNativeCount: Int, callBack: API_TX.LoadCallBack) {
        val nativeAD = NativeAD(mContext, APPID, NativePosID_ExitSplashID, object : NativeAD.NativeAdListener {

            override fun onADLoaded(list: List<NativeADDataRef>) {
                val exitSplashData = ArrayList<TX_NativeBean>()
                for (bean in list) {
                    val ref = TX_NativeBean(bean)
                    exitSplashData.add(ref)
                }
                callBack.onGDTLoadedList(exitSplashData)
            }

            override fun onNoAD(p0: AdError?) {
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
            }


            override fun onADStatusChanged(nativeADDataRef: NativeADDataRef) {

            }

        })
        nativeAD.loadAD(applyNativeCount)
    }

    companion object {

        val APPID = "1104841275"//手电1102079499
        /**礼盒 */
        val NativePosID_GiftID = "2080527818785196"//手电4050302796425155
        /**退出闪屏 */
        val NativePosID_ExitSplashID = "1080103938680832"
        /**清理页 */
        val NativePosID_CleanID = "4010217604912370"
    }

}
