package api.flashlight_unicom

import android.content.Context
import api.bean.API_TX_NativeBean
import api.bean.TX_NativeBean
import com.qq.e.ads.nativ.NativeAD
import com.qq.e.ads.nativ.NativeADDataRef
import com.qq.e.comm.util.AdError
import java.util.*

/**
 * Created by cyly on 16/5/24.
 */
class Gdt_flashlight : API_TX() {
    var nativeGDTDataRefApplyList: ArrayList<API_TX_NativeBean>? = null

    override fun getnativeGDTDataRefapplyList(): ArrayList<API_TX_NativeBean> {
        return if (nativeGDTDataRefApplyList == null)
            ArrayList<API_TX_NativeBean>()
        else
            nativeGDTDataRefApplyList as ArrayList<API_TX_NativeBean>
    }

    override fun loadGiftApplyGDT(context: Context, applyNativeGDTCount: Int, mCallback: API_TX.LoadGDTCallBack) {
        val nativeAD = NativeAD(context, APPID, NativePosID_GiftID, object : NativeAD.NativeAdListener {

            override fun onADLoaded(list: List<NativeADDataRef>?) {
                if (list != null && !list.isEmpty()) {
                    if (nativeGDTDataRefApplyList == null) {
                        nativeGDTDataRefApplyList = ArrayList<API_TX_NativeBean>()
                    }
                    for (bean in list) {
                        val ref = TX_NativeBean(bean)
                        nativeGDTDataRefApplyList!!.add(ref)
                    }
                }
                mCallback.onGDTLoadSuccessed()
            }

            override fun onNoAD(p0: AdError?) {
                mCallback.onGDTLoadFailed()
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
                mCallback.onGDTLoadFailed()
            }
            override fun onADStatusChanged(nativeADDataRef: NativeADDataRef) {

            }
        })
        nativeAD.loadAD(applyNativeGDTCount)
    }

    override fun loadExitSplashGDT(mContext: Context, applyNativeGDTCount: Int, callBack: API_TX.LoadGDTCallBack) {
        val nativeAD = NativeAD(mContext, APPID, NativePosID_ExitSplashID, object : NativeAD.NativeAdListener {

            override fun onADLoaded(list: List<NativeADDataRef>) {
                val exitSplashData = ArrayList<TX_NativeBean>()
                for (bean in list) {
                    val ref = TX_NativeBean(bean)
                    exitSplashData.add(ref)
                }
                callBack.onGDTLoadedList(exitSplashData)
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
            }

            override fun onNoAD(p0: AdError?) {
            }

            override fun onADStatusChanged(nativeADDataRef: NativeADDataRef) {

            }

        })
        nativeAD.loadAD(applyNativeGDTCount)
    }

    companion object {
        val APPID = "1105068822"
        /**礼盒 */
        val NativePosID_GiftID = "7010409709552111"
        /**退出闪屏 */
        val NativePosID_ExitSplashID = "7010409709552111"
    }

}
