package api.folderbox

import android.content.Context
import api.bean.API_TX_NativeBean
import api.bean.TX_NativeBean
import com.qq.e.ads.nativ.NativeAD
import com.qq.e.ads.nativ.NativeADDataRef
import com.qq.e.comm.util.AdError
import java.util.*

/**
 * Created by cyly on 16/5/24.
 */
class Gdt_folderbox : API_TX() {
    var nativeADDataRefApplyList: ArrayList<API_TX_NativeBean>? = null

    override fun getnativeGDTDataRefapplyList(): ArrayList<API_TX_NativeBean> {
        return if (nativeADDataRefApplyList == null)
            ArrayList<API_TX_NativeBean>()
        else
            nativeADDataRefApplyList as ArrayList<API_TX_NativeBean>
    }

    override fun loadGiftApplyGDT(context: Context, count: Int, mCallback: API_TX.LoadGDTCallBack) {
        val nativeAD = NativeAD(context, APPID, NativePosID_GiftID, object : NativeAD.NativeAdListener {

            override fun onADLoaded(list: List<NativeADDataRef>?) {
                if (list != null && !list.isEmpty()) {
                    if (nativeADDataRefApplyList == null) {
                        nativeADDataRefApplyList = ArrayList<API_TX_NativeBean>()
                    }
                    for (bean in list) {
                        val ref = TX_NativeBean(bean)
                        nativeADDataRefApplyList!!.add(ref)
                    }
                }
                mCallback.onGDTLoadSuccessed()
            }


            override fun onNoAD(p0: AdError?) {
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
                mCallback.onGDTLoadFailed()
            }

            override fun onADStatusChanged(nativeADDataRef: NativeADDataRef) {

            }

        })
        nativeAD.loadAD(count)
    }

    override fun loadExitSplashGDT(mContext: Context, applyNativeADCount: Int, callBack: API_TX.LoadGDTCallBack) {
        val nativeAD = NativeAD(mContext, APPID, NativePosID_ExitSplashID, object : NativeAD.NativeAdListener {

            override fun onADLoaded(list: List<NativeADDataRef>) {
                val exitSplashData = ArrayList<TX_NativeBean>()
                for (bean in list) {
                    val ref = TX_NativeBean(bean)
                    exitSplashData.add(ref)
                }
                callBack.onGDTLoadedList(exitSplashData)
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
            }

            override fun onNoAD(p0: AdError?) {
            }

            override fun onADStatusChanged(nativeADDataRef: NativeADDataRef) {

            }

        })
        nativeAD.loadAD(applyNativeADCount)
    }

    override fun loadTuijianGDT(context: Context, tuijianADCount: Int, callBack: API_TX.NativeGDTCallBack) {
        val nativeAD = NativeAD(context, APPID, NativePosID_TuiJian, object : NativeAD.NativeAdListener {

            override fun onADLoaded(list: List<NativeADDataRef>) {
                val exitSplashData = ArrayList<TX_NativeBean>()
                for (bean in list) {
                    val ref = TX_NativeBean(bean)
                    exitSplashData.add(ref)
                }
                callBack.onGDTLoaded(exitSplashData)
            }

            override fun onNoAD(p0: AdError?) {
                callBack.onNoGDT()
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
            }


            override fun onADStatusChanged(nativeADDataRef: NativeADDataRef) {
                callBack.onGDTStatusChanged(nativeADDataRef)
            }
        })
        nativeAD.loadAD(tuijianADCount)
    }

    companion object {
        val APPID = "1102079499"
        /**礼盒 */
        val NativePosID_GiftID = "4050302796425155"
        /**退出闪屏 */
        val NativePosID_ExitSplashID = "1080103938680832"
        /**推荐 */
        val NativePosID_TuiJian = "5060701847799945"
    }

}
