package api.txBanner

import android.app.Activity
import android.util.Log
import android.view.View
import com.qq.e.ads.banner.ADSize
import com.qq.e.ads.banner.AbstractBannerADListener
import com.qq.e.ads.banner.BannerView
import com.qq.e.ads.banner2.UnifiedBannerADListener
import com.qq.e.ads.banner2.UnifiedBannerView
import com.qq.e.comm.util.AdError

class TX_Banner : BannerAPI_TX() {
    private var banner2: UnifiedBannerView? = null
    private var banner: BannerView? = null
    override fun loadBanner(context: Activity?, GDTAPPID: String?, BannerID: String?,refreshTime:Int , callBack: LoadBannerCallBack?): View {
        banner= BannerView(context, ADSize.BANNER, GDTAPPID,  BannerID)
        banner!!.setRefresh(refreshTime)
        banner!!.setADListener(object : AbstractBannerADListener() {
            override fun onNoAD(error: AdError) {
                Log.e("TX", "BannerNoAD，eCode=" + error.errorCode)
                callBack?.onNoBanner(error.errorCode.toString(), error.errorMsg)
            }

            override fun onADClicked() {
                super.onADClicked()
                Log.i("TX", "onBannerClicked")
                callBack?.onBannerClicked()
            }

            override fun onADExposure() {
                super.onADExposure()
                Log.i("TX", "onBannerExposure")
                callBack?.onBannerExposure()
            }

            override fun onADReceiv() {
                Log.i("TX", "onBannerReceiv")
                callBack?.onBannerReceiv()
            }
        })
        /* 发起广告请求，收到广告数据后会展示数据   */
        banner!!.loadAD()
        return banner as BannerView
    }

    override fun loadBanner2(context: Activity?, GDTAPPID: String?, BannerID: String?, refreshTime: Int, callBack: LoadBanner2CallBack?): View {
        banner2 = UnifiedBannerView(context, GDTAPPID, BannerID, object : UnifiedBannerADListener {
            //浮层关闭时调用
            override fun onADCloseOverlay() {
                callBack?.onBannerCloseOverlay()
            }

            //当广告曝光时发起的回调
            override fun onADExposure() {
                callBack?.onBannerExposure()
            }

            //当广告关闭时调用
            override fun onADClosed() {
                callBack?.onBannerClosed()
            }

            //由于广告点击离开 APP 时调用
            override fun onADLeftApplication() {
                callBack?.onBannerLeftApplication()
            }

            //当广告打开浮层时调用，如打开内置浏览器、内容展示浮层，一般发生在点击之后
            override fun onADOpenOverlay() {
                callBack?.onBannerOpenOverlay()
            }

            override fun onNoAD(p0: AdError?) {
                callBack?.onNoBanner(p0?.errorCode.toString(), p0?.errorMsg)
            }

            //广告加载成功回调，表示广告相关的资源已经加载完毕，Ready To Show
            override fun onADReceive() {
                callBack?.onBannerReceiv()
            }

            override fun onADClicked() {
                callBack?.onBannerClicked()
            }
        })
        //设置广告轮播时间，为0或30~120之间的数字，单位为s,0标识不自动轮播
        banner2!!.setRefresh(refreshTime)
        /* 发起广告请求，收到广告数据后会展示数据   */
        banner2!!.loadAD()
        return banner2 as UnifiedBannerView
    }

    override fun bannerDestroy() {
        banner?.destroy()
        banner2?.destroy()
    }
}
