package api.txInfo

import android.content.Context
import android.graphics.Color
import android.support.v4.widget.SwipeRefreshLayout
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.widget.Toast
import com.idotools.sdk.gdt.R
import com.qq.e.ads.contentad.ContentAD
import com.qq.e.ads.contentad.ContentAdData
import java.util.*


class TX_Info : InfoListAPI_TX() {
    private var contentDataList: ArrayList<ContentAdData> = ArrayList()
    private var content: ContentAD? = null
    private var view: View? = null
    private var refreshLayout: SwipeRefreshLayout? = null
    private var myAdapter: LoadMoreAdapter? = null
    private var recyclerView: RecyclerView? = null

    private var tabRecyclerView: RecyclerView? = null
    private var tabAdapter: TabAdapter? = null

    private var index = 0
    private val mItems = arrayOf("推荐", "时事", "军事", "财经", "汽车", "体育", "娱乐", "房产", "科技", "教育", "时尚", "人文", "摄影", "旅游", "健康", "星座", "美食", "家居", "育儿", "科普", "动漫", "图片", "生活", "社会", "国际")
    private val mIds = arrayOf(98, 100, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 115, 116, 117, 118, 119, 122, 123, 128, 136, 143, 1002, 10001)
    private var lastId = 0
    private var p = 0
    override fun loadInfo(context: Context?, GDTAPPID: String?, InfoID: String?, callBack: LoadInfoCallBack?): View? {
        contentDataList.clear()
        index = 0
        initView(context!!)
        setTx(context, GDTAPPID, InfoID, callBack)
        return view
    }


    private fun initView(context: Context) {
        view = LayoutInflater.from(context).inflate(R.layout.info_content, null, false)
        tabRecyclerView = view!!.findViewById(R.id.tab_recycler_view)
        recyclerView = view!!.findViewById(R.id.recycler_view)
        refreshLayout = view!!.findViewById(R.id.refreshLayout)
        refreshLayout!!.setColorSchemeColors(Color.BLUE, Color.GREEN, Color.YELLOW)
        val tabManager = LinearLayoutManager(context)
        tabManager.orientation = LinearLayoutManager.HORIZONTAL
        tabRecyclerView!!.layoutManager = tabManager
        tabAdapter = TabAdapter(context, mItems, object : TabAdapter.TabOnItemClickListener {
            override fun onItemClick(temView: View, position: Int) {
                refreshLayout!!.isRefreshing = true
                index = 0
                p = position
                Log.e("info", mIds[position].toString())
                content!!.loadAD(index, mIds[position], true)
            }
        })

        tabRecyclerView!!.adapter = tabAdapter
        recyclerView!!.layoutManager = LinearLayoutManager(context)
        // 设置加载更多监听
        recyclerView!!.addOnScrollListener(object : RecyclerOnScrollListener() {
            override fun onLoadMore() {
                myAdapter!!.setLoadState(myAdapter!!.LOADING)
                content?.loadAD(index, mIds[p], true)
            }
        })
        /**
         * 设置刷新
         */
        refreshLayout!!.setOnRefreshListener {
            content?.loadAD(index, mIds[p], true)
        }
    }

    private fun setTx(context: Context?, appid: String?, infoId: String?, callBack: LoadInfoCallBack?) {
        myAdapter = LoadMoreAdapter(context!!, contentDataList, object : LoadMoreAdapter.OnItemClickListener {
            override fun onItemClick() {
                callBack?.onItemClick()
            }
        })
        recyclerView!!.adapter = myAdapter
        /**
         * 加载广告
         */
        this.content = ContentAD(context, appid, infoId, object : ContentAD.ContentADListener {
            override fun onNoContentAD(p0: Int) {
                Log.e("info", "onContentADError:$p0")
                refreshLayout!!.isRefreshing = false
                // 显示加载到底的提示
                if (lastId != mIds[p]) {
                    contentDataList.clear()
                    myAdapter!!.notifyDataSetChanged()
                    Toast.makeText(context, "没有更多咯", Toast.LENGTH_SHORT).show()
                } else {
                    if (contentDataList.size > 0) {
                        myAdapter!!.setLoadState(myAdapter!!.LOADING_END)
                    }
                }
                callBack?.onNoContent(p0)
            }

            override fun onContentADError(p0: ContentAdData?, p1: Int) {
                Log.e("info", "onContentADError")
                refreshLayout!!.isRefreshing = false
                myAdapter!!.setLoadState(myAdapter!!.LOADING_COMPLETE)
                Toast.makeText(context, "加载失败", Toast.LENGTH_SHORT).show()
                callBack?.onContentError(p1)
            }

            override fun onADVideoLoaded(p0: ContentAdData?) {
                Log.e("info", "onADVideoLoaded")
            }

            override fun onContentADLoaded(p0: List<ContentAdData>?) {
                Log.e("info", "onContentADLoaded")
                lastId = mIds[p]
                myAdapter!!.setLoadState(myAdapter!!.LOADING_COMPLETE)
                if (p0!!.isNotEmpty()) {
                    if (refreshLayout!!.isRefreshing) {
                        contentDataList.clear()
                        contentDataList.addAll(p0)
                        recyclerView!!.adapter = myAdapter
                        refreshLayout!!.isRefreshing = false
                        index = 0
                    } else {
                        contentDataList.addAll(p0)
                        myAdapter!!.notifyDataSetChanged()
                    }
                    index++
                    callBack?.onContentLoaded()
                } else {
                    callBack?.onContentError(-1)
                }
            }

            override fun onContentADStatusChanged(p0: ContentAdData?) {
                Log.e("info", "onContentADStatusChanged")
            }
        })
        content?.loadAD(index, 98, true)
    }
}

