package api.txInfo

import android.content.Context
import android.graphics.Color
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.idotools.sdk.gdt.R


class TabAdapter(private val context: Context, private val mData: Array<String>, private val listener: TabOnItemClickListener) : RecyclerView.Adapter<TabAdapter.TabViewHolder>() {
    private val isClicks: ArrayList<Boolean> = ArrayList()

    init {
        isClicks.clear()
        for (i in 0 until mData.size) {
            isClicks.add(false)
        }
        isClicks[0]=true
    }

    interface TabOnItemClickListener {
        fun onItemClick(temView: View, position: Int)
    }


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): TabViewHolder {
        // 通过判断显示类型，来创建不同的View
        val view = LayoutInflater.from(parent.context).inflate(R.layout.tab_item, parent, false)
        return TabViewHolder(view)
    }

    override fun onBindViewHolder(holder: TabViewHolder, position: Int) {
        holder.title.text = mData[position]
        holder.title.setOnClickListener {
            for (b in 0 until isClicks.size) {
                isClicks[b] = false
            }
            isClicks[holder.layoutPosition] = true
            notifyDataSetChanged()
            listener.onItemClick(it, position)
        }
        holder.itemView.tag = holder.title
        if (isClicks[position]) {
            holder.title.setTextColor(Color.parseColor("#876742"))
            holder.title.textSize = 18f
        } else {
            holder.title.setTextColor(Color.parseColor("#9B7242"))
            holder.title.textSize = 15f
        }
    }

    override fun getItemCount(): Int {
        return mData.size
    }


    inner class TabViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        var title: TextView = itemView.findViewById(R.id.tab_title)
    }
}
