package api.txNative

import android.content.Context
import android.util.Log
import api.bean.API_TX_NativeBean
import api.bean.TX_NativeBean
import com.qq.e.ads.nativ.NativeAD
import com.qq.e.ads.nativ.NativeADDataRef
import com.qq.e.comm.util.AdError
import java.util.*

class TX_Native : NativeAPI_TX() {
    private var native: NativeAD? = null
    /**
     * 加载原生
     */
    override fun loadNative(context: Context, LoadCount: Int, GDTAPPID: String?, NativePosID: String?, callBack: LoadNativeCallBack?) {
        native = NativeAD(context.applicationContext, GDTAPPID, NativePosID, object : NativeAD.NativeAdListener {
            override fun onADStatusChanged(p0: NativeADDataRef?) {
                Log.i("TX", "NativeonADStatusChanged")
                if (p0 != null) {
                    val ref = TX_NativeBean(p0)
                    callBack?.onNativeStatusChanged(ref)
                }
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
                Log.e("TX", "NativeonError")
                callBack?.onNativeError(p1?.errorCode.toString(), p1?.errorMsg)
            }

            override fun onADLoaded(p0: MutableList<NativeADDataRef>?) {
                Log.i("TX", "NativeonLoaded")
                if (p0 != null && !p0.isEmpty()) {
                    val nativeGDTDataRefApplyList = ArrayList<API_TX_NativeBean>()
                    for (bean in p0) {
                        val ref = TX_NativeBean(bean)
                        nativeGDTDataRefApplyList.add(ref)
                    }
                    callBack?.onNativeSuccessed(nativeGDTDataRefApplyList)
                }
            }

            override fun onNoAD(p0: AdError?) {
                Log.e("TX", "onNoNativeon")
                callBack?.onNoNative()
            }
        })
        native?.loadAD(LoadCount)
    }
}
