package api.txNativeMould

import android.content.Context
import android.util.Log
import com.qq.e.ads.cfg.VideoOption
import com.qq.e.ads.nativ.ADSize
import com.qq.e.ads.nativ.NativeExpressAD
import com.qq.e.ads.nativ.NativeExpressADView
import com.qq.e.ads.nativ.NativeExpressMediaListener
import com.qq.e.comm.constants.AdPatternType
import com.qq.e.comm.pi.AdData
import com.qq.e.comm.util.AdError


class TX_NativeMould : NativeMouldAPI_TX() {
    private var nativeExpress: NativeExpressAD? = null
    private var nativeExpressView: NativeExpressADView? = null
    private val  TAG="NativeMouldAPI_TX"
    override fun loadNativeMould(context: Context?, loadCount: Int, GDTAPPID: String?, NativePosID: String?, callBack: LoadNativeMouldCallBack?) {
        nativeExpress = NativeExpressAD(context, ADSize(ADSize.FULL_WIDTH, ADSize.AUTO_HEIGHT), GDTAPPID, NativePosID, object : NativeExpressAD.NativeExpressADListener {
            override fun onADCloseOverlay(p0: NativeExpressADView?) {
                callBack?.onCloseOverlay()
            }

            override fun onADLoaded(p0: MutableList<NativeExpressADView>?) {
                // 释放前一个NativeExpressADView的资源
                if (nativeExpressView != null) {
                    nativeExpressView?.destroy()
                }
                // 3.返回数据后，SDK 会返回可以用于展示 NativeExpressADView 列表
                nativeExpressView = p0?.get(0)
                if (nativeExpressView?.boundData?.adPatternType == AdPatternType.NATIVE_VIDEO) {
                    nativeExpressView?.setMediaListener(mediaListener)
                }
                nativeExpressView?.render()
                callBack?.onLoaded(nativeExpressView)
            }

            override fun onADOpenOverlay(p0: NativeExpressADView?) {
                callBack?.onOpenOverlay()
            }

            override fun onRenderFail(p0: NativeExpressADView?) {
                callBack?.onRenderFail()
            }

            override fun onADExposure(p0: NativeExpressADView?) {
                callBack?.onExposure()
            }

            override fun onADClosed(p0: NativeExpressADView?) {
                callBack?.onClosed()
            }

            override fun onADLeftApplication(p0: NativeExpressADView?) {
                callBack?.onLeftApplication()
            }

            override fun onNoAD(p0: AdError?) {
                callBack?.onNo(p0!!.errorCode, p0.errorMsg)
            }

            override fun onADClicked(p0: NativeExpressADView?) {
                callBack?.onClicked()
            }

            override fun onRenderSuccess(p0: NativeExpressADView?) {
                callBack?.onRenderSuccess()
            }
        })
        // 注意：如果您在平台上新建原生模板广告位时，选择了支持视频，那么可以进行个性化设置（可选）
        nativeExpress?.setVideoOption(VideoOption.Builder()
                .setAutoPlayPolicy(VideoOption.AutoPlayPolicy.WIFI) // WIFI 环境下可以自动播放视频
                .setAutoPlayMuted(true) // 自动播放时为静音
                .build())
        nativeExpress?.setMaxVideoDuration(30)
        nativeExpress?.loadAD(1)
    }
    private val mediaListener = object : NativeExpressMediaListener {
        override fun onVideoInit(nativeExpressADView: NativeExpressADView) {
            Log.i(TAG, "onVideoInit: " + nativeExpressADView.boundData.getProperty(AdData.VideoPlayer::class.java).toString())
        }

        override fun onVideoLoading(nativeExpressADView: NativeExpressADView) {
            Log.i(TAG, "onVideoLoading")
        }

        override fun onVideoReady(nativeExpressADView: NativeExpressADView, l: Long) {
            Log.i(TAG, "onVideoReady")
        }

        override fun onVideoStart(nativeExpressADView: NativeExpressADView) {
            Log.i(TAG, "onVideoStart: " +nativeExpressADView.boundData.getProperty(AdData.VideoPlayer::class.java).toString())
        }

        override fun onVideoPause(nativeExpressADView: NativeExpressADView) {
            Log.i(TAG, "onVideoPause: " + nativeExpressADView.boundData.getProperty(AdData.VideoPlayer::class.java).toString())
        }

        override fun onVideoComplete(nativeExpressADView: NativeExpressADView) {
            Log.i(TAG, "onVideoComplete: " +nativeExpressADView.boundData.getProperty(AdData.VideoPlayer::class.java).toString())
        }

        override fun onVideoError(nativeExpressADView: NativeExpressADView, adError: AdError) {
            Log.i(TAG, "onVideoError")
        }

        override fun onVideoPageOpen(nativeExpressADView: NativeExpressADView) {
            Log.i(TAG, "onVideoPageOpen")
        }

        override fun onVideoPageClose(nativeExpressADView: NativeExpressADView) {
            Log.i(TAG, "onVideoPageClose")
        }
    }

    override fun nativeMouldViewDestroy() {
        if (nativeExpressView != null) {
            nativeExpressView?.destroy()
        }
    }
}
